## Alpha API Report File for "@fluidframework/container-runtime-definitions"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

// @alpha @sealed
export interface IContainerRuntime extends IProvideFluidDataStoreRegistry, IContainerRuntimeBaseWithCombinedEvents {
    readonly attachState: AttachState;
    // (undocumented)
    readonly clientDetails: IClientDetails;
    // (undocumented)
    readonly clientId: string | undefined;
    // (undocumented)
    readonly connected: boolean;
    // (undocumented)
    readonly deltaManager: IDeltaManager<ISequencedDocumentMessage, IDocumentMessage>;
    // (undocumented)
    readonly flushMode: FlushMode;
    getAbsoluteUrl(relativeUrl: string): Promise<string | undefined>;
    readonly isDirty: boolean;
    // (undocumented)
    readonly options: Record<string | number, any>;
    // (undocumented)
    readonly scope: FluidObject;
    // (undocumented)
    readonly storage: IDocumentStorageService;
}

// @alpha @sealed (undocumented)
export type IContainerRuntimeBaseWithCombinedEvents = IContainerRuntimeBase & IEventProvider<IContainerRuntimeEvents>;

// @alpha @sealed
export interface IContainerRuntimeEvents extends IContainerRuntimeBaseEvents, ISummarizerEvents {
    // (undocumented)
    (event: "dirty" | "disconnected" | "saved" | "attached", listener: () => void): any;
    // (undocumented)
    (event: "connected", listener: (clientId: string) => void): any;
}

// @alpha @deprecated (undocumented)
export interface IContainerRuntimeWithResolveHandle_Deprecated extends IContainerRuntime {
    // (undocumented)
    readonly IFluidHandleContext: IFluidHandleContext;
    // (undocumented)
    resolveHandle(request: IRequest): Promise<IResponse>;
}

// @alpha @sealed (undocumented)
export interface ISummarizeEventProps {
    // (undocumented)
    currentAttempt: number;
    // (undocumented)
    error?: any;
    failureMessage?: string;
    isLastSummary?: boolean;
    // (undocumented)
    maxAttempts: number;
    // (undocumented)
    result: "success" | "failure" | "canceled";
}

// @alpha @sealed (undocumented)
export interface ISummarizerEvents extends IEvent {
    // (undocumented)
    (event: "summarize", listener: (props: ISummarizeEventProps & ISummarizerObservabilityProps) => void): any;
    // (undocumented)
    (event: "summarizeAllAttemptsFailed", listener: (props: Omit<ISummarizeEventProps, "result"> & ISummarizerObservabilityProps) => void): any;
    // (undocumented)
    (event: "summarizerStop", listener: (props: {
        stopReason: SummarizerStopReason;
        error?: any;
    } & ISummarizerObservabilityProps) => void): any;
    // (undocumented)
    (event: "summarizerStart", listener: (props: {
        onBehalfOf: string;
    } & ISummarizerObservabilityProps) => void): any;
    // (undocumented)
    (event: "summarizerStartupFailed", listener: (props: {
        reason: SummarizerStopReason;
    } & ISummarizerObservabilityProps) => void): any;
}

// @alpha @sealed (undocumented)
export interface ISummarizerObservabilityProps {
    // (undocumented)
    numUnsummarizedNonRuntimeOps: number;
    // (undocumented)
    numUnsummarizedRuntimeOps: number;
}

// @alpha @sealed (undocumented)
export type SummarizerStopReason =
/**
* Summarizer client failed to summarize in all attempts.
*/
"failToSummarize"
/**
* Parent client reported that it is no longer connected.
*/
| "parentNotConnected"
/**
* Parent client reported that it is no longer elected the summarizer.
* This is the normal flow; a disconnect will always trigger the parent
* client to no longer be elected as responsible for summaries. Then it
* tries to stop its spawned summarizer client.
*/
| "notElectedParent"
/**
* We are not already running the summarizer and we are not the current elected client id.
*/
| "notElectedClient"
/**
* Summarizer client was disconnected
*/
| "summarizerClientDisconnected"
/**
* running summarizer threw an exception
*/
| "summarizerException"
/**
* The previous summary state on the summarizer is not the most recently acked summary. this also happens when the
* first submitSummary attempt fails for any reason and there's a 2nd summary attempt without an ack
*/
| "latestSummaryStateStale";

// (No @packageDocumentation comment for this package)

```
